//-------------------------------------
//dirbox.cpp
//-------- ----------------------------

class DirBox
{
 private:
  TListBox *box;
  TFileListBox *fbox;

  int Hidden,CurPos,p;
  AnsiString Drv,wk,wk0;
  struct DIR
   {
    AnsiString dir;
    int flg;
   }wdir,dname[500];

  AnsiString DirBox::MakeCurPath(int flg=0);
  void AddCurList(void);

 public:
  DirBox()   {  CurPos=0; p=Hidden=0; };
  AnsiString GetDrive(int flg=0);    //  flg=0 Drive .. A (:\)    flg !=0  a:\\
  AnsiString GetCurDir(int flg=0);   // flg=0 A:\, A:\test       flg !=0 a:\test\\
  AnsiString GetItemDir(int flg=0);  // flg=0 A:\, a:\test       flg !=0 a:\test\\
  AnsiString GetItem(int flg=0);     //ItemIndex ́@StringsԂ

  void RenDir(AnsiString name);           //rename dir

  void SetDrive(AnsiString drv);    // A
  int GetCurPos();
  int GetFlg(int indx);
  void DirDisp(int flg=0);   //flg !=0 Ȃ@JgfBNg[̍蒼

  void SetBox(TListBox *p,TFileListBox *p1);
  void SetHidden(int flg=0);
};

//----------`--------------------------------

AnsiString DirBox::GetItem(int flg)
{
 return box->Items->Strings[box->ItemIndex].Trim();
}
AnsiString DirBox::MakeCurPath(int flg)    //a:\\, a:\\test\\ ret
{
 int i;

 wk0=dname[0].dir.Trim();
 wk=wk0;
 for(i=1;i<=CurPos;i++)
  {
   wk=dname[i].dir.Trim();
   wk0=wk0+dname[i].dir.Trim();
   wk=wk0;
   wk0=wk0+"\\";
  }
 if((flg !=0)&&(CurPos>0))
  {
   wk0=wk0.SubString(1,wk0.Length()-1);
  }
 return wk0;
}

void DirBox::RenDir(AnsiString name)
{
 int i,len;
 AnsiString w,sp;

 w=dname[box->ItemIndex].dir;

 len=w.Length();
 sp="";
 for(i=1;i<len;i++)
  {
   if(w.SubString(i,1)==" ")
    { sp=sp+" "; }
   else
    break;
  }

 dname[box->ItemIndex].dir=sp+name;
 box->Items->Strings[box->ItemIndex]=dname[box->ItemIndex].dir;

 return;
}

AnsiString DirBox::GetCurDir(int flg)   //Drive ..a:\\, A:\\test
{
  wk=MakeCurPath(1);
  if((flg==0)||(CurPos==0))  return wk;
  else                       return wk+"\\";
}

AnsiString DirBox::GetItemDir(int flg)  //Drive .. A:\\, a:\\test
{
  wk=MakeCurPath(1);

  if(box->ItemIndex>CurPos)
   {
    if(CurPos>0)
     wk=wk+"\\"+box->Items->Strings[box->ItemIndex].Trim();
    else
     wk=wk+box->Items->Strings[box->ItemIndex].Trim();
   }

 if((flg==0)||(box->ItemIndex==0))  return wk;
 else                       return wk+"\\";
}

AnsiString DirBox::GetDrive(int flg)
{
 if(flg==0)return Drv;
 else      return Drv+"\:\\";
 }
int DirBox::GetFlg(int indx)
{ return dname[indx].flg; } //return hflg[indx]; }

void DirBox::SetHidden(int flg) { Hidden=flg;  }

void DirBox::SetBox(TListBox *p,TFileListBox *p1) { box=p; fbox=p1;  }

int DirBox::GetCurPos() { return CurPos; }

void DirBox::SetDrive(AnsiString drv)
   {
    Drv=drv.SubString(1,1);
    CurPos=0;
    dname[CurPos].dir=Drv+"\:\\";
   }

void DirBox::AddCurList(void)
{
  AnsiString txt;

  if(box->ItemIndex>CurPos)
   {
     CurPos++;
     txt=box->Items->Strings[box->ItemIndex];
     dname[CurPos].dir=txt;
     dname[CurPos].flg=dname[box->ItemIndex].flg;
   }
  else
   {
    if(box->ItemIndex<0)
     CurPos=0;
    else
     CurPos=box->ItemIndex;
   }
}

void DirBox::DirDisp(int flg)  //flg !=0 Ȃ@JgfBNg[̍蒼
{
 AnsiString Drv,w,w1,fname,path0,path,Space,sp="                    ";
 WIN32_FIND_DATA f_data;
 HANDLE handle;
 int i;
 if(flg!=0)
  AddCurList();
 w=dname[0].dir.Trim();
 path0=w;
 for(i=1;i<=CurPos;i++)
  {
   path0=dname[i].dir.Trim();
   w=w+dname[i].dir.Trim();
   path0=w;
   w=w+"\\";
  }

 fbox->Directory=path0;

 w=w+"*.*";

 box->Items->Clear();

//-------CurrentPath-------

 for(i=0;i<=CurPos;i++)
  { if(i>0)
     path=sp.SubString(1,i*2);

   path=path+dname[i].dir.Trim();
   box->Items->Add(path);

  }

//-----------------------

 p=CurPos+1;
 Space=sp.SubString(1,i*2);

 handle=FindFirstFile(w.c_str(),&f_data);
 if(handle !=INVALID_HANDLE_VALUE)
  {
  if((f_data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) !=0)
    {
     // check dir

     if(f_data.cFileName[0] !='.')
      {
       w=Space+f_data.cFileName;
       if((f_data.dwFileAttributes&FILE_ATTRIBUTE_HIDDEN) ==0)
        {
         dname[p].dir=w;
         dname[p++].flg=0;
        }
       else
        if(Hidden !=0)
          {
           dname[p].dir=w;
           dname[p++].flg=255;
          }
      }
     else
      {
        w1=f_data.cFileName;
        if(w1.Length()>1)
         {
          if(w1.SubString(2,1) !=".")
           {
             dname[p].dir=Space+w1;
             dname[p++].flg=0;
           }

         }
      }
    }

  while(FindNextFile(handle,&f_data) !=false)
  {
   if((f_data.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)!=0)
    {

     if(f_data.cFileName[0] !='.')
      {
        w=Space+f_data.cFileName;
        if((f_data.dwFileAttributes&FILE_ATTRIBUTE_HIDDEN) ==0)
         {
          dname[p].dir=w;
          dname[p++].flg=0;
         }
        else
         if(Hidden !=0)
          {
           dname[p].dir=w;
           dname[p++].flg=255;
          }
      }
     else
      {
        w1=f_data.cFileName;
        if(w1.Length()>1)
         {
          if(w1.SubString(2,1) !=".")
           {
             dname[p].dir=Space+w1;
             dname[p++].flg=0;
           }
         }
      }

    }
  }	//while
  FindClose(handle);

  //Exchange Sort
  int ip;
  for(i=CurPos+1;i<p;i++)
   {
    for(ip=i+1;ip<p;ip++)
     {
       if(dname[i].dir.UpperCase()>dname[ip].dir.UpperCase())
         {
          wdir=dname[i];
          dname[i]=dname[ip];
          dname[ip]=wdir;
         }
     }
   }

  //Add ListBox

  for(i=CurPos+1;i<p;i++)
   { box->Items->Add(dname[i].dir); }

  box->ItemIndex=CurPos;
 }
}

//------------ DirBox End--------------------------------------
